Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ISF/isftbl.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ISF/isftbl.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ISF/isftbl.F90	(revision 13727)
@@ -25,4 +25,5 @@
    !! * Substitutions
 #  include "do_loop_substitute.h90"
+#  include "domzgr_substitute.h90"
 
 CONTAINS
@@ -56,4 +57,6 @@
       REAL(wp), DIMENSION(jpi,jpj) :: zhtbl   ! thickness of the tbl
       REAL(wp), DIMENSION(jpi,jpj) :: zfrac   ! thickness of the tbl
+      INTEGER :: jk                            ! loop index
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze3t,ze3u,ze3v ! e3 
       !!--------------------------------------------------------------------
       ! 
@@ -64,13 +67,16 @@
          zhtbl = phtbl
          !
+         DO jk = 1, jpk
+            ze3u(:,:,jk) = e3u(:,:,jk,Kmm)
+         END DO 
          ! compute tbl lvl and thickness
-         CALL isf_tbl_lvl( hu(:,:,Kmm), e3u(:,:,:,Kmm), ktop, ikbot, zhtbl, zfrac )
+         CALL isf_tbl_lvl( hu(:,:,Kmm), ze3u, ktop, ikbot, zhtbl, zfrac )
          !
          ! compute tbl property at U point
-         CALL isf_tbl_avg( miku, ikbot, zhtbl, zfrac, e3u(:,:,:,Kmm), pvarin, zvarout )
+         CALL isf_tbl_avg( miku, ikbot, zhtbl, zfrac, ze3u, pvarin, zvarout )
          !
          ! compute tbl property at T point
          pvarout(1,:) = 0._wp
-         DO_2D_11_01
+         DO_2D( 1, 1, 0, 1 )
             pvarout(ji,jj) = 0.5_wp * (zvarout(ji,jj) + zvarout(ji-1,jj))
          END_2D
@@ -82,13 +88,16 @@
          zhtbl = phtbl
          !
+         DO jk = 1, jpk
+            ze3v(:,:,jk) = e3v(:,:,jk,Kmm)
+         END DO 
          ! compute tbl lvl and thickness
-         CALL isf_tbl_lvl( hv(:,:,Kmm), e3v(:,:,:,Kmm), ktop, ikbot, zhtbl, zfrac )
+         CALL isf_tbl_lvl( hv(:,:,Kmm), ze3v, ktop, ikbot, zhtbl, zfrac )
          !
          ! compute tbl property at V point
-         CALL isf_tbl_avg( mikv, ikbot, zhtbl, zfrac, e3v(:,:,:,Kmm), pvarin, zvarout )
+         CALL isf_tbl_avg( mikv, ikbot, zhtbl, zfrac, ze3v, pvarin, zvarout )
          !
          ! pvarout is an averaging of wet point
          pvarout(:,1) = 0._wp
-         DO_2D_01_11
+         DO_2D( 0, 1, 1, 1 )
             pvarout(ji,jj) = 0.5_wp * (zvarout(ji,jj) + zvarout(ji,jj-1))
          END_2D
@@ -98,5 +107,8 @@
          !
          ! compute tbl property at T point
-         CALL isf_tbl_avg( ktop, kbot, phtbl, pfrac, e3t(:,:,:,Kmm), pvarin, pvarout )
+         DO jk = 1, jpk
+            ze3t(:,:,jk) = e3t(:,:,jk,Kmm)
+         END DO 
+         CALL isf_tbl_avg( ktop, kbot, phtbl, pfrac, ze3t, pvarin, pvarout )
          !
       END SELECT
@@ -126,5 +138,5 @@
       !
       ! compute tbl top.bottom level and thickness
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! tbl top/bottom indices initialisation
@@ -164,5 +176,5 @@
       !
       ! get htbl
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! tbl top/bottom indices initialisation
@@ -181,5 +193,5 @@
       !
       ! get pfrac
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! tbl top/bottom indices initialisation
@@ -212,8 +224,8 @@
       ! phtbl need to be bounded by water column thickness before
       ! test: if htbl = water column thickness, should return mbathy
-      ! test: if htbl = 0 should return ktop (phtbl cap to e3t(ji,jj,1))
+      ! test: if htbl = 0 should return ktop (phtbl cap to pe3t(ji,jj,1))
       !
       ! get ktbl
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! determine the deepest level influenced by the boundary layer
@@ -249,5 +261,5 @@
       ! test: this routine run with pdep = 0 should return 1
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ! comput ktop
          ikt = 2
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ISF/isfutils.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ISF/isfutils.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ISF/isfutils.F90	(revision 13727)
@@ -12,8 +12,8 @@
    !!----------------------------------------------------------------------
 
-   USE iom           , ONLY: iom_open, iom_get, iom_close, jpdom_data        ! read input file
+   USE iom           , ONLY: iom_open, iom_get, iom_close, jpdom_global      ! read input file
    USE lib_fortran   , ONLY: glob_sum, glob_min, glob_max                    ! compute global value
-   USE par_oce       , ONLY: jpi,jpj,jpk, jpnij                              ! domain size
-   USE dom_oce       , ONLY: nldi, nlei, nldj, nlej, narea, tmask_h, tmask_i ! local domain
+   USE par_oce       , ONLY: jpi,jpj,jpk, jpnij, Nis0, Nie0, Njs0, Nje0      ! domain size
+   USE dom_oce       , ONLY: narea, tmask_h, tmask_i                         ! local domain
    USE in_out_manager, ONLY: i8, wp, lwp, numout                             ! miscelenious
    USE lib_mpp
@@ -47,5 +47,5 @@
 
       CALL iom_open( TRIM(cdfile), inum )
-      CALL iom_get( inum, jpdom_data, TRIM(cdvar), pvar)
+      CALL iom_get( inum, jpdom_global, TRIM(cdvar), pvar)
       CALL iom_close(inum)
 
@@ -84,6 +84,6 @@
       !
       ! local MOD sum
-      DO jj=nldj,nlej
-         DO ji=nldi,nlei
+      DO jj=Njs0,Nje0
+         DO ji=Nis0,Nie0
             idums = ABS(MOD(TRANSFER(pvar(ji,jj), ip),imodd))
             itmps(narea) = MOD(itmps(narea) + idums, imods)
@@ -138,6 +138,6 @@
       ! local MOD sum
       DO jk=1,jpk
-         DO jj=nldj,nlej
-            DO ji=nldi,nlei
+         DO jj=Njs0,Nje0
+            DO ji=Nis0,Nie0
                idums = ABS(MOD(TRANSFER(pvar(ji,jj,jk), ip),imodd))
                itmps(narea) = MOD(itmps(narea) + idums, imods)
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/halo_mng.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/halo_mng.F90	(revision 13727)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/halo_mng.F90	(revision 13727)
@@ -0,0 +1,194 @@
+MODULE halo_mng
+   !!======================================================================
+   !!                       ***  MODULE  halo_mng  ***
+   !! Ocean numerics:  massively parallel processing library
+   !!=====================================================================
+   !! History :  OPA  !  1994  (M. Guyon, J. Escobar, M. Imbard)
+   !Original code
+   !!            4.0  !  2019  (CMCC - ASC)  initial version of halo management module
+   !in_out_manager
+   !!----------------------------------------------------------------------
+
+   USE dom_oce       ! ocean space and time domain
+   USE lbclnk        ! ocean lateral boundary condition (or mpp link) 
+
+   IMPLICIT NONE
+   PRIVATE
+
+   INTERFACE halo_mng_resize
+      MODULE PROCEDURE halo_mng_resize_2D, halo_mng_resize_3D, halo_mng_resize_4D, halo_mng_resize_5D
+   END INTERFACE
+
+   PUBLIC halo_mng_resize
+   PUBLIC halo_mng_init
+   PUBLIC halo_mng_set
+
+   INTEGER :: jpi_1, jpj_1
+   INTEGER :: jpimax_1, jpjmax_1
+   INTEGER :: Nis0_1, Njs0_1
+   INTEGER :: Nie0_1, Nje0_1
+CONTAINS
+
+   SUBROUTINE halo_mng_init( )
+
+        jpi_1 = jpi
+        jpj_1 = jpj
+
+        Nis0_1 = Nis0
+        Njs0_1 = Njs0
+
+        Nie0_1 = Nie0
+        Nje0_1 = Nje0
+
+   	jpimax_1 = jpimax
+   	jpjmax_1 = jpjmax
+
+   END SUBROUTINE halo_mng_init
+
+   SUBROUTINE halo_mng_set( khls )
+   
+        INTEGER, INTENT(in   )    ::   khls
+
+        nn_hls = khls
+
+        jpi = jpi_1 + 2*khls -2
+        jpj = jpj_1 + 2*khls -2
+
+        jpi = jpi_1 + 2*khls -2
+        jpj = jpj_1 + 2*khls -2
+        
+        jpimax = jpimax_1 + 2*khls -2
+        jpjmax = jpjmax_1 + 2*khls -2
+
+        Nis0 = Nis0_1 + khls - 1
+        Njs0 = Njs0_1 + khls - 1
+
+        Nie0 = Nie0_1 + khls - 1
+        Nje0 = Nje0_1 + khls - 1
+
+   END SUBROUTINE halo_mng_set
+   
+	SUBROUTINE halo_mng_resize_2D(pta, cdna, psgn, fillval)
+	
+		REAL(wp), POINTER, DIMENSION(:,:) :: pta
+		CHARACTER(len=1), INTENT(in)  :: cdna
+		REAL(wp), INTENT(in)  :: psgn
+		REAL(wp), OPTIONAL, INTENT(in ) :: fillval
+		REAL(wp), POINTER, DIMENSION(:,:) :: zpta
+		INTEGER :: offset
+		INTEGER :: pta_size_i, pta_size_j
+
+		pta_size_i = SIZE(pta,1)
+		pta_size_j = SIZE(pta,2)
+		
+		! check if the current size of pta is equal to the current expected dimension
+		IF (pta_size_i .ne. jpi) THEN
+			ALLOCATE (zpta(jpi, jpj))
+			offset = abs((jpi - pta_size_i) / 2) 
+
+			IF (pta_size_i .lt. jpi) THEN
+				zpta (offset+1 : offset+pta_size_i, offset+1 : offset+pta_size_j) = pta
+			ELSE
+				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj)
+			END IF
+			CALL lbc_lnk( 'halo_mng_resize_2D', zpta, cdna, psgn, pfillval=fillval)
+			DEALLOCATE(pta)
+			pta => zpta
+		END IF
+		
+	END SUBROUTINE halo_mng_resize_2D
+
+	SUBROUTINE halo_mng_resize_3D(pta, cdna, psgn, fillval)
+	
+		REAL(wp), POINTER, DIMENSION(:,:,:) :: pta
+		CHARACTER(len=1), INTENT(in)  :: cdna
+		REAL(wp), INTENT(in)  :: psgn
+		REAL(wp), OPTIONAL, INTENT(in ) :: fillval
+		REAL(wp), POINTER, DIMENSION(:,:,:) :: zpta
+		INTEGER :: offset
+		INTEGER :: pta_size_i, pta_size_j
+
+		pta_size_i = SIZE(pta,1)
+		pta_size_j = SIZE(pta,2)
+		
+		! check if the current size of pta is equal to the current expected dimension
+		IF (pta_size_i .ne. jpi) THEN
+			ALLOCATE (zpta(jpi, jpj, jpk))
+			offset = abs((jpi - pta_size_i) / 2) 
+
+			IF (pta_size_i .lt. jpi) THEN
+				zpta (offset+1 : offset+pta_size_i, offset+1 : offset+pta_size_j, :) = pta
+			ELSE
+				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj, :)
+			END IF
+			CALL lbc_lnk( 'halo_mng_resize_3D', zpta, cdna, psgn, pfillval=fillval)
+			DEALLOCATE(pta)
+			pta => zpta
+		END IF
+		
+	END SUBROUTINE halo_mng_resize_3D
+
+	SUBROUTINE halo_mng_resize_4D(pta, cdna, psgn, fillval, fjpt)
+	
+		REAL(wp), POINTER, DIMENSION(:,:,:,:) :: pta
+		CHARACTER(len=1), INTENT(in)  :: cdna
+		REAL(wp), INTENT(in)  :: psgn
+		REAL(wp), OPTIONAL, INTENT(in) :: fillval
+		INTEGER , INTENT(in) ::   fjpt 
+		REAL(wp), POINTER, DIMENSION(:,:,:,:) :: zpta
+		INTEGER :: offset
+		INTEGER :: pta_size_i, pta_size_j
+
+		pta_size_i = SIZE(pta,1)
+		pta_size_j = SIZE(pta,2)
+		
+		! check if the current size of pta is equal to the current expected dimension
+		IF (pta_size_i .ne. jpi) THEN
+			ALLOCATE (zpta(jpi, jpj, jpk, jpt))
+			offset = abs((jpi - pta_size_i) / 2) 
+
+			IF (pta_size_i .lt. jpi) THEN
+				zpta (offset+1 : offset+pta_size_i, offset+1 : offset+pta_size_j, :, :) = pta
+			ELSE
+				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj, :, :)
+			END IF
+			CALL lbc_lnk( 'halo_mng_resize_4D', zpta(:,:,:,fjpt), cdna, psgn, pfillval=fillval)
+			DEALLOCATE(pta)
+			pta => zpta
+		END IF
+		
+	END SUBROUTINE halo_mng_resize_4D
+	
+	SUBROUTINE halo_mng_resize_5D(pta, cdna, psgn, fillval, kjpt, fjpt)
+	
+		REAL(wp), POINTER, DIMENSION(:,:,:,:,:) :: pta
+		CHARACTER(len=1), INTENT(in)  :: cdna
+		REAL(wp), INTENT(in)  :: psgn
+		REAL(wp), OPTIONAL, INTENT(in) :: fillval
+		INTEGER , OPTIONAL, INTENT(in) :: kjpt            ! number of tracers
+		INTEGER , INTENT(in) :: fjpt            
+		REAL(wp), POINTER, DIMENSION(:,:,:,:,:) :: zpta
+		INTEGER :: offset
+		INTEGER :: pta_size_i, pta_size_j
+
+		pta_size_i = SIZE(pta,1)
+		pta_size_j = SIZE(pta,2)
+		
+		! check if the current size of pta is equal to the current expected dimension
+		IF (pta_size_i .ne. jpi) THEN
+			ALLOCATE (zpta(jpi, jpj, jpk, kjpt, jpt))
+			offset = abs((jpi - pta_size_i) / 2) 
+
+			IF (pta_size_i .lt. jpi) THEN
+				zpta (offset+1 : offset+pta_size_i, offset+1 : offset+pta_size_j, :, :, :) = pta
+			ELSE
+				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj, :, :, :)
+			END IF
+			CALL lbc_lnk( 'halo_mng_resize_5D', zpta(:,:,:,:,fjpt), cdna, psgn, pfillval=fillval)
+			DEALLOCATE(pta)
+			pta => zpta
+		END IF
+		
+	END SUBROUTINE halo_mng_resize_5D
+	
+END MODULE
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/lbc_lnk_multi_generic.h90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/lbc_lnk_multi_generic.h90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/lbc_lnk_multi_generic.h90	(revision 13727)
@@ -1,40 +1,63 @@
-#if defined DIM_2d
-#   define ARRAY_TYPE(i,j,k,l)   REAL(wp), DIMENSION(i,j)
-#   define PTR_TYPE              TYPE(PTR_2D)
-#   define PTR_ptab              pt2d
-#endif
-#if defined DIM_3d
-#   define ARRAY_TYPE(i,j,k,l)   REAL(wp), DIMENSION(i,j,k)
-#   define PTR_TYPE              TYPE(PTR_3D)
-#   define PTR_ptab              pt3d
-#endif
-#if defined DIM_4d
-#   define ARRAY_TYPE(i,j,k,l)   REAL(wp), DIMENSION(i,j,k,l)
-#   define PTR_TYPE              TYPE(PTR_4D)
-#   define PTR_ptab              pt4d
+#if defined SINGLE_PRECISION
+#   if defined DIM_2d
+#      define ARRAY_TYPE(i,j,k,l)   REAL(sp), DIMENSION(i,j)
+#      define PTR_TYPE              TYPE(PTR_2D_sp)
+#      define PTR_ptab              pt2d
+#   endif
+#   if defined DIM_3d
+#      define ARRAY_TYPE(i,j,k,l)   REAL(sp), DIMENSION(i,j,k)
+#      define PTR_TYPE              TYPE(PTR_3D_sp)
+#      define PTR_ptab              pt3d
+#   endif
+#   if defined DIM_4d
+#      define ARRAY_TYPE(i,j,k,l)   REAL(sp), DIMENSION(i,j,k,l)
+#      define PTR_TYPE              TYPE(PTR_4D_sp)
+#      define PTR_ptab              pt4d
+#   endif
+#   define PRECISION sp
+#else
+#   if defined DIM_2d
+#      define ARRAY_TYPE(i,j,k,l)   REAL(dp), DIMENSION(i,j)
+#      define PTR_TYPE              TYPE(PTR_2D_dp)
+#      define PTR_ptab              pt2d
+#   endif
+#   if defined DIM_3d
+#      define ARRAY_TYPE(i,j,k,l)   REAL(dp), DIMENSION(i,j,k)
+#      define PTR_TYPE              TYPE(PTR_3D_dp)
+#      define PTR_ptab              pt3d
+#   endif
+#   if defined DIM_4d
+#      define ARRAY_TYPE(i,j,k,l)   REAL(dp), DIMENSION(i,j,k,l)
+#      define PTR_TYPE              TYPE(PTR_4D_dp)
+#      define PTR_ptab              pt4d
+#   endif
+#   define PRECISION dp
 #endif
 
-   SUBROUTINE ROUTINE_MULTI( cdname                                                                             &
-      &                    , pt1, cdna1, psgn1, pt2 , cdna2 , psgn2 , pt3 , cdna3 , psgn3 , pt4, cdna4, psgn4   &
-      &                    , pt5, cdna5, psgn5, pt6 , cdna6 , psgn6 , pt7 , cdna7 , psgn7 , pt8, cdna8, psgn8   &
-      &                    , pt9, cdna9, psgn9, pt10, cdna10, psgn10, pt11, cdna11, psgn11                      &
-      &                    , kfillmode, pfillval, lsend, lrecv, ihlcom )
+   SUBROUTINE ROUTINE_MULTI( cdname                                                                               &
+      &                    , pt1 , cdna1 , psgn1 , pt2 , cdna2 , psgn2 , pt3 , cdna3 , psgn3 , pt4 , cdna4 , psgn4   &
+      &                    , pt5 , cdna5 , psgn5 , pt6 , cdna6 , psgn6 , pt7 , cdna7 , psgn7 , pt8 , cdna8 , psgn8   &
+      &                    , pt9 , cdna9 , psgn9 , pt10, cdna10, psgn10, pt11, cdna11, psgn11, pt12, cdna12, psgn12  &
+      &                    , pt13, cdna13, psgn13, pt14, cdna14, psgn14, pt15, cdna15, psgn15, pt16, cdna16, psgn16  &
+      &                    , kfillmode, pfillval, lsend, lrecv )
       !!---------------------------------------------------------------------
-      CHARACTER(len=*)   ,                   INTENT(in   ) :: cdname  ! name of the calling subroutine
-      ARRAY_TYPE(:,:,:,:)          , TARGET, INTENT(inout) :: pt1     ! arrays on which the lbc is applied
-      ARRAY_TYPE(:,:,:,:), OPTIONAL, TARGET, INTENT(inout) :: pt2  , pt3  , pt4  , pt5  , pt6  , pt7  , pt8  , pt9  , pt10  , pt11
-      CHARACTER(len=1)                     , INTENT(in   ) :: cdna1   ! nature of pt2D. array grid-points
-      CHARACTER(len=1)   , OPTIONAL        , INTENT(in   ) :: cdna2, cdna3, cdna4, cdna5, cdna6, cdna7, cdna8, cdna9, cdna10, cdna11
-      REAL(wp)                             , INTENT(in   ) :: psgn1   ! sign used across the north fold
-      REAL(wp)           , OPTIONAL        , INTENT(in   ) :: psgn2, psgn3, psgn4, psgn5, psgn6, psgn7, psgn8, psgn9, psgn10, psgn11
-      INTEGER            , OPTIONAL        , INTENT(in   ) :: kfillmode   ! filling method for halo over land (default = constant)
-      REAL(wp)           , OPTIONAL        , INTENT(in   ) :: pfillval    ! background value (used at closed boundaries)
-      LOGICAL, DIMENSION(4), OPTIONAL      , INTENT(in   ) :: lsend, lrecv   ! indicate how communications are to be carried out
-      INTEGER            , OPTIONAL        , INTENT(in   ) :: ihlcom         ! number of ranks and rows to be communicated
+      CHARACTER(len=*)     ,                   INTENT(in   ) ::   cdname  ! name of the calling subroutine
+      ARRAY_TYPE(:,:,:,:)            , TARGET, INTENT(inout) ::   pt1     ! arrays on which the lbc is applied
+      ARRAY_TYPE(:,:,:,:)  , OPTIONAL, TARGET, INTENT(inout) ::   pt2   , pt3   , pt4   , pt5   , pt6   , pt7   , pt8   , pt9  , &
+         &                                                        pt10  , pt11  , pt12  , pt13  , pt14  , pt15  , pt16
+      CHARACTER(len=1)                       , INTENT(in   ) ::   cdna1   ! nature of pt2D. array grid-points
+      CHARACTER(len=1)     , OPTIONAL        , INTENT(in   ) ::   cdna2 , cdna3 , cdna4 , cdna5 , cdna6 , cdna7 , cdna8 , cdna9, &
+         &                                                        cdna10, cdna11, cdna12, cdna13, cdna14, cdna15, cdna16
+      REAL(wp)                               , INTENT(in   ) ::   psgn1   ! sign used across the north fold
+      REAL(wp)             , OPTIONAL        , INTENT(in   ) ::   psgn2 , psgn3 , psgn4 , psgn5 , psgn6 , psgn7 , psgn8 , psgn9, &
+         &                                                        psgn10, psgn11, psgn12, psgn13, psgn14, psgn15, psgn16
+      INTEGER              , OPTIONAL        , INTENT(in   ) ::   kfillmode   ! filling method for halo over land (default = constant)
+      REAL(wp)             , OPTIONAL        , INTENT(in   ) ::   pfillval    ! background value (used at closed boundaries)
+      LOGICAL, DIMENSION(4), OPTIONAL        , INTENT(in   ) ::   lsend, lrecv   ! indicate how communications are to be carried out
       !!
       INTEGER                          ::   kfld        ! number of elements that will be attributed
-      PTR_TYPE         , DIMENSION(11) ::   ptab_ptr    ! pointer array
-      CHARACTER(len=1) , DIMENSION(11) ::   cdna_ptr    ! nature of ptab_ptr grid-points
-      REAL(wp)         , DIMENSION(11) ::   psgn_ptr    ! sign used across the north fold boundary
+      PTR_TYPE         , DIMENSION(16) ::   ptab_ptr    ! pointer array
+      CHARACTER(len=1) , DIMENSION(16) ::   cdna_ptr    ! nature of ptab_ptr grid-points
+      REAL(wp)         , DIMENSION(16) ::   psgn_ptr    ! sign used across the north fold boundary
       !!---------------------------------------------------------------------
       !
@@ -55,6 +78,11 @@
       IF( PRESENT(psgn10) )   CALL ROUTINE_LOAD( pt10, cdna10, psgn10, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
       IF( PRESENT(psgn11) )   CALL ROUTINE_LOAD( pt11, cdna11, psgn11, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn12) )   CALL ROUTINE_LOAD( pt12, cdna12, psgn12, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn13) )   CALL ROUTINE_LOAD( pt13, cdna13, psgn13, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn14) )   CALL ROUTINE_LOAD( pt14, cdna14, psgn14, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn15) )   CALL ROUTINE_LOAD( pt15, cdna15, psgn15, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn16) )   CALL ROUTINE_LOAD( pt16, cdna16, psgn16, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
       !
-      CALL lbc_lnk_ptr    ( cdname,               ptab_ptr, cdna_ptr, psgn_ptr, kfld, kfillmode, pfillval, lsend, lrecv, ihlcom )
+      CALL lbc_lnk_ptr( cdname, ptab_ptr, cdna_ptr, psgn_ptr, kfld, kfillmode, pfillval, lsend, lrecv )
       !
    END SUBROUTINE ROUTINE_MULTI
@@ -79,4 +107,5 @@
    END SUBROUTINE ROUTINE_LOAD
 
+#undef PRECISION
 #undef ARRAY_TYPE
 #undef PTR_TYPE
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/lbc_nfd_ext_generic.h90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/lbc_nfd_ext_generic.h90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/lbc_nfd_ext_generic.h90	(revision 13727)
@@ -8,5 +8,11 @@
 #   define L_SIZE(ptab)          1
 #endif
-#define ARRAY_TYPE(i,j,k,l,f)    REAL(wp),INTENT(inout)::ARRAY_IN(i,j,k,l,f)
+#if defined SINGLE_PRECISION
+#   define ARRAY_TYPE(i,j,k,l,f)    REAL(sp),INTENT(inout)::ARRAY_IN(i,j,k,l,f)
+#   define PRECISION sp
+#else
+#   define ARRAY_TYPE(i,j,k,l,f)    REAL(dp),INTENT(inout)::ARRAY_IN(i,j,k,l,f)
+#   define PRECISION dp
+#endif
 
    SUBROUTINE ROUTINE_NFD( ptab, cd_nat, psgn, kextj )
@@ -28,5 +34,5 @@
       !
       SELECT CASE ( jpni )
-      CASE ( 1 )     ;   ipj = nlcj       ! 1 proc only  along the i-direction
+      CASE ( 1 )     ;   ipj = jpj        ! 1 proc only  along the i-direction
       CASE DEFAULT   ;   ipj = 4          ! several proc along the i-direction
       END SELECT
@@ -149,4 +155,5 @@
    END SUBROUTINE ROUTINE_NFD
 
+#undef PRECISION
 #undef ARRAY_TYPE
 #undef ARRAY_IN
